#ifndef __HVMLOADER_CONFIG_H__
#define __HVMLOADER_CONFIG_H__

#define IOAPIC_BASE_ADDRESS 0xfec00000
#define IOAPIC_ID           0x01
#define IOAPIC_VERSION      0x11

#define LAPIC_BASE_ADDRESS  0xfee00000
#define LAPIC_ID(vcpu_id)   ((vcpu_id) * 2)

#define PCI_ISA_DEVFN       0x08    /* dev 1, fn 0 */
#define PCI_ISA_IRQ_MASK    0x0ca0U /* ISA IRQs 5,7,10,11 are PCI connected */

#define ROMBIOS_SEG            0xF000
#define ROMBIOS_BEGIN          0x000F0000
#define ROMBIOS_SIZE           0x00010000
#define ROMBIOS_MAXOFFSET      0x0000FFFF
#define ROMBIOS_END            (ROMBIOS_BEGIN + ROMBIOS_SIZE)

/* Memory map. */
#define HYPERCALL_PHYSICAL_ADDRESS    0x00080000
#define VGABIOS_PHYSICAL_ADDRESS      0x000C0000
#define ETHERBOOT_PHYSICAL_ADDRESS    0x000C8000
#define VMXASSIST_PHYSICAL_ADDRESS    0x000D0000
#define SMBIOS_PHYSICAL_ADDRESS       0x000E9000
#define SMBIOS_MAXIMUM_SIZE           0x00001000
#define ACPI_PHYSICAL_ADDRESS         0x000EA000
#define ROMBIOS_PHYSICAL_ADDRESS      0x000F0000

#endif /* __HVMLOADER_CONFIG_H__ */
